/* LICENSE BLOCK
Part of mde: a Modular D game-oriented Engine
Copyright © 2007-2008 Diggory Hardy

This program is free software: you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation, either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

/** This module allows any renderer to be created from a string parameter. */
module mde.gui.renderer.createRenderer;

public import mde.gui.renderer.IRenderer;
import mde.gui.renderer.SimpleRenderer;

import tango.util.log.Log : Log, Logger;

private Logger logger;
static this () {
    logger = Log.getLogger ("mde.gui.renderer.createRenderer");
}

/** Return an instance of renderer name.
 *
 * If name does not match any renderer class, SimpleRenderer is used as a default. */
IRenderer createRenderer (char[] name) {
    if (name == "Simple") return new SimpleRenderer;
    else {
        logger.warn ("Renderer name \"" ~ name ~ "\" is not recognised. Defaulting to SimpleRenderer.");
        return new SimpleRenderer;
    }
}
